

<!DOCTYPE html>



<head>
    <meta charset="utf-8" />
    <meta name="author" content="Apple Inc." />
    <meta name="viewport" content="width=device-width initial-scale=1" />
    
    <title>Extensions &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css" />
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css" />
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico" />
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png" />
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png" />
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png" />
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png" />
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png" />
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png" />
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png" />
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png" />
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png" />
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339" /> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2"><a class="reference internal" href="ClassesAndStructures.html">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="Extensions.html#">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">← Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="Extensions.html#">Extensions</a><ul>
<li><a class="reference internal" href="Extensions.html#ID470">Extension Syntax</a></li>
<li><a class="reference internal" href="Extensions.html#ID152">Computed Properties</a></li>
<li><a class="reference internal" href="Extensions.html#ID153">Initializers</a></li>
<li><a class="reference internal" href="Extensions.html#ID154">Methods</a><ul>
<li><a class="reference internal" href="Extensions.html#ID155">Mutating Instance Methods</a></li>
</ul>
</li>
<li><a class="reference internal" href="Extensions.html#ID156">Subscripts</a></li>
<li><a class="reference internal" href="Extensions.html#ID157">Nested Types</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="extensions">
<h1>Extensions<a class="headerlink" href="Extensions.html#extensions" title="Permalink to this headline"></a></h1>
<p><em>Extensions</em> add new functionality to an existing class, structure, enumeration, or protocol type. This includes the ability to extend types for which you do not have access to the original source code (known as <em>retroactive modeling</em>). Extensions are similar to categories in Objective-C. (Unlike Objective-C categories, Swift extensions do not have names.)</p>
<p>Extensions in Swift can:</p>
<ul class="simple">
<li>Add computed instance properties and computed type properties</li>
<li>Define instance methods and type methods</li>
<li>Provide new initializers</li>
<li>Define subscripts</li>
<li>Define and use new nested types</li>
<li>Make an existing type conform to a protocol</li>
</ul>
<p>In Swift, you can even extend a protocol to provide implementations of its requirements or add additional functionality that conforming types can take advantage of. For more details, see <a class="reference internal" href="Protocols.html#ID521"><span class="std std-ref">Protocol Extensions</span></a>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Extensions can add new functionality to a type, but they cannot override existing functionality.</p>
</div>
<div class="section" id="ID470">
<h2>Extension Syntax<a class="headerlink" href="Extensions.html#ID470" title="Permalink to this headline"></a></h2>
<p>Declare extensions with the <code class="docutils literal"><span class="pre">extension</span></code> keyword:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">SomeType</span> {
</li><li>    <span class="c">// new functionality to add to SomeType goes here</span>
</li><li>}
</li></ol></pre></div></div>
<p>An extension can extend an existing type to make it adopt one or more protocols. To add protocol conformance, you write the protocol names the same way as you write them for a class or structure:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">SomeType</span>: <span class="nc">SomeProtocol</span>, <span class="nc">AnotherProtocol</span> {
</li><li>    <span class="c">// implementation of protocol requirements goes here</span>
</li><li>}
</li></ol></pre></div></div>
<p>Adding protocol conformance in this way is described in <a class="reference internal" href="Protocols.html#ID277"><span class="std std-ref">Adding Protocol Conformance with an Extension</span></a>.</p>
<p>An extension can be used to extend an existing generic type, as described in <a class="reference internal" href="Generics.html#ID185"><span class="std std-ref">Extending a Generic Type</span></a>. You can also extend a generic type to conditionally add functionality, as described in <a class="reference internal" href="Generics.html#ID553"><span class="std std-ref">Extensions with a Generic Where Clause</span></a>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If you define an extension to add new functionality to an existing type, the new functionality will be available on all existing instances of that type, even if they were created before the extension was defined.</p>
</div>
</div>
<div class="section" id="ID152">
<h2>Computed Properties<a class="headerlink" href="Extensions.html#ID152" title="Permalink to this headline"></a></h2>
<p>Extensions can add computed instance properties and computed type properties to existing types. This example adds five computed instance properties to Swift’s built-in <code class="docutils literal"><span class="pre">Double</span></code> type, to provide basic support for working with distance units:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">Double</span> {
</li><li>    <span class="k">var</span> <span class="nv">km</span>: <span class="nc">Double</span> { <span class="k">return</span> <span class="k">self</span> * <span class="m">1_000.0</span> }
</li><li>    <span class="k">var</span> <span class="nv">m</span>: <span class="nc">Double</span> { <span class="k">return</span> <span class="k">self</span> }
</li><li>    <span class="k">var</span> <span class="nv">cm</span>: <span class="nc">Double</span> { <span class="k">return</span> <span class="k">self</span> / <span class="m">100.0</span> }
</li><li>    <span class="k">var</span> <span class="nv">mm</span>: <span class="nc">Double</span> { <span class="k">return</span> <span class="k">self</span> / <span class="m">1_000.0</span> }
</li><li>    <span class="k">var</span> <span class="nv">ft</span>: <span class="nc">Double</span> { <span class="k">return</span> <span class="k">self</span> / <span class="m">3.28084</span> }
</li><li>}
</li><li><span class="k">let</span> <span class="nv">oneInch</span> = <span class="m">25.4</span>.<span class="nv">mm</span>
</li><li><span class="nv">print</span>(<span class="s">&quot;One inch is </span>\<span class="p">(</span><span class="nv">oneInch</span><span class="p">)</span><span class="s"> meters&quot;</span>)
</li><li><span class="c">// Prints &quot;One inch is 0.0254 meters&quot;</span>
</li><li><span class="k">let</span> <span class="nv">threeFeet</span> = <span class="m">3</span>.<span class="nv">ft</span>
</li><li><span class="nv">print</span>(<span class="s">&quot;Three feet is </span>\<span class="p">(</span><span class="nv">threeFeet</span><span class="p">)</span><span class="s"> meters&quot;</span>)
</li><li><span class="c">// Prints &quot;Three feet is 0.914399970739201 meters&quot;</span>
</li></ol></pre></div></div>
<p>These computed properties express that a <code class="docutils literal"><span class="pre">Double</span></code> value should be considered as a certain unit of length. Although they are implemented as computed properties, the names of these properties can be appended to a floating-point literal value with dot syntax, as a way to use that literal value to perform distance conversions.</p>
<p>In this example, a <code class="docutils literal"><span class="pre">Double</span></code> value of <code class="docutils literal"><span class="pre">1.0</span></code> is considered to represent “one meter”. This is why the <code class="docutils literal"><span class="pre">m</span></code> computed property returns <code class="docutils literal"><span class="pre">self</span></code>—the expression <code class="docutils literal"><span class="pre">1.m</span></code> is considered to calculate a <code class="docutils literal"><span class="pre">Double</span></code> value of <code class="docutils literal"><span class="pre">1.0</span></code>.</p>
<p>Other units require some conversion to be expressed as a value measured in meters. One kilometer is the same as 1,000 meters, so the <code class="docutils literal"><span class="pre">km</span></code> computed property multiplies the value by <code class="docutils literal"><span class="pre">1_000.00</span></code> to convert into a number expressed in meters. Similarly, there are 3.28084 feet in a meter, and so the <code class="docutils literal"><span class="pre">ft</span></code> computed property divides the underlying <code class="docutils literal"><span class="pre">Double</span></code> value by <code class="docutils literal"><span class="pre">3.28084</span></code>, to convert it from feet to meters.</p>
<p>These properties are read-only computed properties, and so they are expressed without the <code class="docutils literal"><span class="pre">get</span></code> keyword, for brevity. Their return value is of type <code class="docutils literal"><span class="pre">Double</span></code>, and can be used within mathematical calculations wherever a <code class="docutils literal"><span class="pre">Double</span></code> is accepted:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">aMarathon</span> = <span class="m">42</span>.<span class="nv">km</span> + <span class="m">195</span>.<span class="nv">m</span>
</li><li><span class="nv">print</span>(<span class="s">&quot;A marathon is </span>\<span class="p">(</span><span class="nv">aMarathon</span><span class="p">)</span><span class="s"> meters long&quot;</span>)
</li><li><span class="c">// Prints &quot;A marathon is 42195.0 meters long&quot;</span>
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Extensions can add new computed properties, but they cannot add stored properties, or add property observers to existing properties.</p>
</div>
</div>
<div class="section" id="ID153">
<h2>Initializers<a class="headerlink" href="Extensions.html#ID153" title="Permalink to this headline"></a></h2>
<p>Extensions can add new initializers to existing types. This enables you to extend other types to accept your own custom types as initializer parameters, or to provide additional initialization options that were not included as part of the type’s original implementation.</p>
<p>Extensions can add new convenience initializers to a class, but they cannot add new designated initializers or deinitializers to a class. Designated initializers and deinitializers must always be provided by the original class implementation.</p>
<p>If you use an extension to add an initializer to a value type that provides default values for all of its stored properties and does not define any custom initializers, you can call the default initializer and memberwise initializer for that value type from within your extension’s initializer. This wouldn’t be the case if you had written the initializer as part of the value type’s original implementation, as described in <a class="reference internal" href="Initialization.html#ID215"><span class="std std-ref">Initializer Delegation for Value Types</span></a>.</p>
<p>If you use an extension to add an initializer to a structure that was declared in another module, the new initializer can’t access <code class="docutils literal"><span class="pre">self</span></code> until it calls an initializer from the defining module.</p>
<p>The example below defines a custom <code class="docutils literal"><span class="pre">Rect</span></code> structure to represent a geometric rectangle. The example also defines two supporting structures called <code class="docutils literal"><span class="pre">Size</span></code> and <code class="docutils literal"><span class="pre">Point</span></code>, both of which provide default values of <code class="docutils literal"><span class="pre">0.0</span></code> for all of their properties:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">Size</span> {
</li><li>    <span class="k">var</span> <span class="nv">width</span> = <span class="m">0.0</span>, <span class="nv">height</span> = <span class="m">0.0</span>
</li><li>}
</li><li><span class="k">struct</span> <span class="nv">Point</span> {
</li><li>    <span class="k">var</span> <span class="nv">x</span> = <span class="m">0.0</span>, <span class="nv">y</span> = <span class="m">0.0</span>
</li><li>}
</li><li><span class="k">struct</span> <span class="nv">Rect</span> {
</li><li>    <span class="k">var</span> <span class="nv">origin</span> = <span class="nv">Point</span>()
</li><li>    <span class="k">var</span> <span class="nv">size</span> = <span class="nv">Size</span>()
</li><li>}
</li></ol></pre></div></div>
<p>Because the <code class="docutils literal"><span class="pre">Rect</span></code> structure provides default values for all of its properties, it receives a default initializer and a memberwise initializer automatically, as described in <a class="reference internal" href="Initialization.html#ID213"><span class="std std-ref">Default Initializers</span></a>. These initializers can be used to create new <code class="docutils literal"><span class="pre">Rect</span></code> instances:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">defaultRect</span> = <span class="nv">Rect</span>()
</li><li><span class="k">let</span> <span class="nv">memberwiseRect</span> = <span class="nv">Rect</span>(<span class="nv">origin</span>: <span class="nv">Point</span>(<span class="nv">x</span>: <span class="m">2.0</span>, <span class="nv">y</span>: <span class="m">2.0</span>),
</li><li>   <span class="nv">size</span>: <span class="nv">Size</span>(<span class="nv">width</span>: <span class="m">5.0</span>, <span class="nv">height</span>: <span class="m">5.0</span>))
</li></ol></pre></div></div>
<p>You can extend the <code class="docutils literal"><span class="pre">Rect</span></code> structure to provide an additional initializer that takes a specific center point and size:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">Rect</span> {
</li><li>    <span class="k">init</span>(<span class="nv">center</span>: <span class="nc">Point</span>, <span class="nv">size</span>: <span class="nc">Size</span>) {
</li><li>        <span class="k">let</span> <span class="nv">originX</span> = <span class="nv">center</span>.<span class="nv">x</span> - (<span class="nv">size</span>.<span class="nv">width</span> / <span class="m">2</span>)
</li><li>        <span class="k">let</span> <span class="nv">originY</span> = <span class="nv">center</span>.<span class="nv">y</span> - (<span class="nv">size</span>.<span class="nv">height</span> / <span class="m">2</span>)
</li><li>        <span class="k">self</span>.<span class="nv">init</span>(<span class="nv">origin</span>: <span class="nv">Point</span>(<span class="nv">x</span>: <span class="nv">originX</span>, <span class="nv">y</span>: <span class="nv">originY</span>), <span class="nv">size</span>: <span class="nv">size</span>)
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>This new initializer starts by calculating an appropriate origin point based on the provided <code class="docutils literal"><span class="pre">center</span></code> point and <code class="docutils literal"><span class="pre">size</span></code> value. The initializer then calls the structure’s automatic memberwise initializer <code class="docutils literal"><span class="pre">init(origin:size:)</span></code>, which stores the new origin and size values in the appropriate properties:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">centerRect</span> = <span class="nv">Rect</span>(<span class="nv">center</span>: <span class="nv">Point</span>(<span class="nv">x</span>: <span class="m">4.0</span>, <span class="nv">y</span>: <span class="m">4.0</span>),
</li><li>                      <span class="nv">size</span>: <span class="nv">Size</span>(<span class="nv">width</span>: <span class="m">3.0</span>, <span class="nv">height</span>: <span class="m">3.0</span>))
</li><li><span class="c">// centerRect&#39;s origin is (2.5, 2.5) and its size is (3.0, 3.0)</span>
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If you provide a new initializer with an extension, you are still responsible for making sure that each instance is fully initialized once the initializer completes.</p>
</div>
</div>
<div class="section" id="ID154">
<h2>Methods<a class="headerlink" href="Extensions.html#ID154" title="Permalink to this headline"></a></h2>
<p>Extensions can add new instance methods and type methods to existing types. The following example adds a new instance method called <code class="docutils literal"><span class="pre">repetitions</span></code> to the <code class="docutils literal"><span class="pre">Int</span></code> type:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">Int</span> {
</li><li>    <span class="k">func</span> <span class="nv">repetitions</span>(<span class="nv">task</span>: () -&gt; <span class="nc">Void</span>) {
</li><li>        <span class="k">for</span> <span class="k">_</span> <span class="k">in</span> <span class="m">0</span>..&lt;<span class="k">self</span> {
</li><li>            <span class="nv">task</span>()
</li><li>        }
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>The <code class="docutils literal"><span class="pre">repetitions(task:)</span></code> method takes a single argument of type <code class="docutils literal"><span class="pre">()</span> <span class="pre">-&gt;</span> <span class="pre">Void</span></code>, which indicates a function that has no parameters and does not return a value.</p>
<p>After defining this extension, you can call the <code class="docutils literal"><span class="pre">repetitions(task:)</span></code> method on any integer to perform a task that many number of times:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="m">3</span>.<span class="nv">repetitions</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&quot;Hello!&quot;</span>)
</li><li>}
</li><li><span class="c">// Hello!</span>
</li><li><span class="c">// Hello!</span>
</li><li><span class="c">// Hello!</span>
</li></ol></pre></div></div>
<div class="section" id="ID155">
<h3>Mutating Instance Methods<a class="headerlink" href="Extensions.html#ID155" title="Permalink to this headline"></a></h3>
<p>Instance methods added with an extension can also modify (or <em>mutate</em>) the instance itself. Structure and enumeration methods that modify <code class="docutils literal"><span class="pre">self</span></code> or its properties must mark the instance method as <code class="docutils literal"><span class="pre">mutating</span></code>, just like mutating methods from an original implementation.</p>
<p>The example below adds a new mutating method called <code class="docutils literal"><span class="pre">square</span></code> to Swift’s <code class="docutils literal"><span class="pre">Int</span></code> type, which squares the original value:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">Int</span> {
</li><li>    <span class="k">mutating</span> <span class="k">func</span> <span class="nv">square</span>() {
</li><li>        <span class="k">self</span> = <span class="k">self</span> * <span class="k">self</span>
</li><li>    }
</li><li>}
</li><li><span class="k">var</span> <span class="nv">someInt</span> = <span class="m">3</span>
</li><li><span class="nv">someInt</span>.<span class="nv">square</span>()
</li><li><span class="c">// someInt is now 9</span>
</li></ol></pre></div></div>
</div>
</div>
<div class="section" id="ID156">
<h2>Subscripts<a class="headerlink" href="Extensions.html#ID156" title="Permalink to this headline"></a></h2>
<p>Extensions can add new subscripts to an existing type. This example adds an integer subscript to Swift’s built-in <code class="docutils literal"><span class="pre">Int</span></code> type. This subscript <code class="docutils literal"><span class="pre">[n]</span></code> returns the decimal digit <code class="docutils literal"><span class="pre">n</span></code> places in from the right of the number:</p>
<ul class="simple">
<li><code class="docutils literal"><span class="pre">123456789[0]</span></code> returns <code class="docutils literal"><span class="pre">9</span></code></li>
<li><code class="docutils literal"><span class="pre">123456789[1]</span></code> returns <code class="docutils literal"><span class="pre">8</span></code></li>
</ul>
<p>…and so on:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">Int</span> {
</li><li>    <span class="k">subscript</span>(<span class="nv">digitIndex</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Int</span> {
</li><li>        <span class="k">var</span> <span class="nv">decimalBase</span> = <span class="m">1</span>
</li><li>        <span class="k">for</span> <span class="k">_</span> <span class="k">in</span> <span class="m">0</span>..&lt;<span class="nv">digitIndex</span> {
</li><li>            <span class="nv">decimalBase</span> *= <span class="m">10</span>
</li><li>        }
</li><li>        <span class="k">return</span> (<span class="k">self</span> / <span class="nv">decimalBase</span>) % <span class="m">10</span>
</li><li>    }
</li><li>}
</li><li><span class="m">746381295</span>[<span class="m">0</span>]
</li><li><span class="c">// returns 5</span>
</li><li><span class="m">746381295</span>[<span class="m">1</span>]
</li><li><span class="c">// returns 9</span>
</li><li><span class="m">746381295</span>[<span class="m">2</span>]
</li><li><span class="c">// returns 2</span>
</li><li><span class="m">746381295</span>[<span class="m">8</span>]
</li><li><span class="c">// returns 7</span>
</li></ol></pre></div></div>
<p>If the <code class="docutils literal"><span class="pre">Int</span></code> value does not have enough digits for the requested index, the subscript implementation returns <code class="docutils literal"><span class="pre">0</span></code>, as if the number had been padded with zeros to the left:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="m">746381295</span>[<span class="m">9</span>]
</li><li><span class="c">// returns 0, as if you had requested:</span>
</li><li><span class="m">0746381295</span>[<span class="m">9</span>]
</li></ol></pre></div></div>
</div>
<div class="section" id="ID157">
<h2>Nested Types<a class="headerlink" href="Extensions.html#ID157" title="Permalink to this headline"></a></h2>
<p>Extensions can add new nested types to existing classes, structures, and enumerations:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">Int</span> {
</li><li>    <span class="k">enum</span> <span class="nv">Kind</span> {
</li><li>        <span class="k">case</span> <span class="nv">negative</span>, <span class="nv">zero</span>, <span class="nv">positive</span>
</li><li>    }
</li><li>    <span class="k">var</span> <span class="nv">kind</span>: <span class="nc">Kind</span> {
</li><li>        <span class="k">switch</span> <span class="k">self</span> {
</li><li>        <span class="k">case</span> <span class="m">0</span>:
</li><li>            <span class="k">return</span> .<span class="nv">zero</span>
</li><li>        <span class="k">case</span> <span class="k">let</span> <span class="nv">x</span> <span class="k">where</span> <span class="nv">x</span> &gt; <span class="m">0</span>:
</li><li>            <span class="k">return</span> .<span class="nv">positive</span>
</li><li>        <span class="k">default</span>:
</li><li>            <span class="k">return</span> .<span class="nv">negative</span>
</li><li>        }
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>This example adds a new nested enumeration to <code class="docutils literal"><span class="pre">Int</span></code>. This enumeration, called <code class="docutils literal"><span class="pre">Kind</span></code>, expresses the kind of number that a particular integer represents. Specifically, it expresses whether the number is negative, zero, or positive.</p>
<p>This example also adds a new computed instance property to <code class="docutils literal"><span class="pre">Int</span></code>, called <code class="docutils literal"><span class="pre">kind</span></code>, which returns the appropriate <code class="docutils literal"><span class="pre">Kind</span></code> enumeration case for that integer.</p>
<p>The nested enumeration can now be used with any <code class="docutils literal"><span class="pre">Int</span></code> value:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">printIntegerKinds</span>(<span class="k">_</span> <span class="nv">numbers</span>: [<span class="nc">Int</span>]) {
</li><li>    <span class="k">for</span> <span class="nv">number</span> <span class="k">in</span> <span class="nv">numbers</span> {
</li><li>        <span class="k">switch</span> <span class="nv">number</span>.<span class="nv">kind</span> {
</li><li>        <span class="k">case</span> .<span class="nv">negative</span>:
</li><li>            <span class="nv">print</span>(<span class="s">&quot;- &quot;</span>, <span class="nv">terminator</span>: <span class="s">&quot;&quot;</span>)
</li><li>        <span class="k">case</span> .<span class="nv">zero</span>:
</li><li>            <span class="nv">print</span>(<span class="s">&quot;0 &quot;</span>, <span class="nv">terminator</span>: <span class="s">&quot;&quot;</span>)
</li><li>        <span class="k">case</span> .<span class="nv">positive</span>:
</li><li>            <span class="nv">print</span>(<span class="s">&quot;+ &quot;</span>, <span class="nv">terminator</span>: <span class="s">&quot;&quot;</span>)
</li><li>        }
</li><li>    }
</li><li>    <span class="nv">print</span>(<span class="s">&quot;&quot;</span>)
</li><li>}
</li><li><span class="nv">printIntegerKinds</span>([<span class="m">3</span>, <span class="m">19</span>, <span class="m">-27</span>, <span class="m">0</span>, <span class="m">-6</span>, <span class="m">0</span>, <span class="m">7</span>])
</li><li><span class="c">// Prints &quot;+ + - 0 - 0 + &quot;</span>
</li></ol></pre></div></div>
<p>This function, <code class="docutils literal"><span class="pre">printIntegerKinds(_:)</span></code>, takes an input array of <code class="docutils literal"><span class="pre">Int</span></code> values and iterates over those values in turn. For each integer in the array, the function considers the <code class="docutils literal"><span class="pre">kind</span></code> computed property for that integer, and prints an appropriate description.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last"><code class="docutils literal"><span class="pre">number.kind</span></code> is already known to be of type <code class="docutils literal"><span class="pre">Int.Kind</span></code>. Because of this, all of the <code class="docutils literal"><span class="pre">Int.Kind</span></code> case values can be written in shorthand form inside the <code class="docutils literal"><span class="pre">switch</span></code> statement, such as <code class="docutils literal"><span class="pre">.negative</span></code> rather than <code class="docutils literal"><span class="pre">Int.Kind.negative</span></code>.</p>
</div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="NestedTypes.html">Nested Types</a></p>
        <p class="next"><a href="Protocols.html">Protocols</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple's beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  </body>
</html>
